
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Response_actionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const response_actions = await db.response_actions.create(
            {
                id: data.id || undefined,
        
        action_type: data.action_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        requested_at: data.requested_at
        ||
        null
            ,
            
        executed_at: data.executed_at
        ||
        null
            ,
            
        target: data.target
        ||
        null
            ,
            
        action_result: data.action_result
        ||
        null
            ,
            
        automated: data.automated
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await response_actions.setIncident( data.incident || null, {
            transaction,
        });
        
        await response_actions.setPlaybook( data.playbook || null, {
            transaction,
        });
        
        await response_actions.setRequested_by( data.requested_by || null, {
            transaction,
        });
        
        await response_actions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return response_actions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const response_actionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                action_type: item.action_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                requested_at: item.requested_at
            ||
            null
            ,
            
                executed_at: item.executed_at
            ||
            null
            ,
            
                target: item.target
            ||
            null
            ,
            
                action_result: item.action_result
            ||
            null
            ,
            
                automated: item.automated
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const response_actions = await db.response_actions.bulkCreate(response_actionsData, { transaction });

        // For each item created, replace relation files
        

        return response_actions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const response_actions = await db.response_actions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.action_type !== undefined) updatePayload.action_type = data.action_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.requested_at !== undefined) updatePayload.requested_at = data.requested_at;
        
        
        if (data.executed_at !== undefined) updatePayload.executed_at = data.executed_at;
        
        
        if (data.target !== undefined) updatePayload.target = data.target;
        
        
        if (data.action_result !== undefined) updatePayload.action_result = data.action_result;
        
        
        if (data.automated !== undefined) updatePayload.automated = data.automated;
        
        
        updatePayload.updatedById = currentUser.id;

        await response_actions.update(updatePayload, {transaction});

        
        
        if (data.incident !== undefined) {
            await response_actions.setIncident(
              
              data.incident,
              
              { transaction }
            );
        }
        
        if (data.playbook !== undefined) {
            await response_actions.setPlaybook(
              
              data.playbook,
              
              { transaction }
            );
        }
        
        if (data.requested_by !== undefined) {
            await response_actions.setRequested_by(
              
              data.requested_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await response_actions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return response_actions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const response_actions = await db.response_actions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of response_actions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of response_actions) {
                await record.destroy({transaction});
            }
        });


        return response_actions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const response_actions = await db.response_actions.findByPk(id, options);

        await response_actions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await response_actions.destroy({
            transaction
        });

        return response_actions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const response_actions = await db.response_actions.findOne(
            { where },
            { transaction },
        );

        if (!response_actions) {
            return response_actions;
        }

        const output = response_actions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.incident = await response_actions.getIncident({
            transaction
        });
        
        
        output.playbook = await response_actions.getPlaybook({
            transaction
        });
        
        
        output.requested_by = await response_actions.getRequested_by({
            transaction
        });
        
        
        output.organizations = await response_actions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.incidents,
        as: 'incident',
        
        where: filter.incident ? {
          [Op.or]: [
            { id: { [Op.in]: filter.incident.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.incident.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.response_playbooks,
        as: 'playbook',
        
        where: filter.playbook ? {
          [Op.or]: [
            { id: { [Op.in]: filter.playbook.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.playbook.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'requested_by',
        
        where: filter.requested_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.requested_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.requested_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.target) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'response_actions',
                        'target',
                        filter.target,
                    ),
                };
            }
            
            if (filter.action_result) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'response_actions',
                        'action_result',
                        filter.action_result,
                    ),
                };
            }
            

            
            

            
            if (filter.requested_atRange) {
                const [start, end] = filter.requested_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.executed_atRange) {
                const [start, end] = filter.executed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    executed_at: {
                    ...where.executed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    executed_at: {
                    ...where.executed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.action_type) {
                where = {
                    ...where,
                action_type: filter.action_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.automated) {
                where = {
                    ...where,
                automated: filter.automated,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.response_actions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'response_actions',
                        'target',
                        query,
                    ),
                ],
            };
        }

        const records = await db.response_actions.findAll({
            attributes: [ 'id', 'target' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['target', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.target,
        }));
    }

    
};

